PrecacheSound("ui/hitsound_electro1.wav"); //todo move to a good place
PrecacheSound("ui/hitsound_retro1.wav"); //todo move to a good place

::currentWeapons <- player_collection(0);

::SwitchToNextWeapon <- function(player)
{
    local playerIndex = player.entindex();
    local oldWeaponIndex = currentWeapons[playerIndex];
    currentWeapons[playerIndex]++;

    if (currentWeapons[playerIndex] < GUNGAME_ORDER.len()-1)
    {
        local oldWeaponTT = GetWeaponTypeByName(GUNGAME_ORDER[oldWeaponIndex]);
        local newWeaponTT = GetWeaponTypeByName(GUNGAME_ORDER[currentWeapons[playerIndex]]);
        ChangePlayerClass(player, "playerclass" in newWeaponTT ? newWeaponTT.playerclass : TF_CLASS_SOLDIER);
        if (newWeaponTT != oldWeaponTT)
        {
            if (player.GetActiveWeapon() && player.GetActiveWeapon().GetClassname() == "tf_weapon_minigun")
            {
                player.RemoveCond(TF_COND_AIMING);
                player.GetActiveWeapon().Kill();
                RunWithDelay(this, 0.1, PullOutWeapon, player, newWeaponTT);
                return;
            }
            else
                PullOutWeapon(player, newWeaponTT);
            EmitSoundEx({
                sound_name = "ui/hitsound_retro1.wav",
                filter_type = RECIPIENT_FILTER_SINGLE_PLAYER,
                entity = player,
                filter_param = player,
                speaker_entity = player
            });
        }
    }
    else
        EndRound();
}

::ChangePlayerClass <- function(player, newClass)
{
    if (newClass == player.GetPlayerClass())
        return;
    player.SetPlayerClass(newClass);
    return;
    SetPropInt(player, "m_bForcedSkin", 1);
    SetPropInt(player, "m_nForcedSkin", 5);

    player.SetCustomModelWithClassAnimations(mercModelPath);
    player.SetModelScale(1.0, 0);

    local itemsToKill = [];
    for (local item = player.FirstMoveChild(); item != null; item = item.NextMovePeer())
        if (startswith(item.GetClassname(), "tf_we"))
            itemsToKill.push(item);
    foreach (item in itemsToKill)
        item.Kill();

    //player.AddCustomAttribute("move speed bonus", 1.5, -1);
    player.AddCustomAttribute("cancel falling damage", 1, -1);
    player.AddCustomAttribute("crit mod disabled hidden", 0, -1);
    player.AddCustomAttribute("voice pitch scale", 0, -1);

    player.SetHealth(150);
    player.SetMaxHealth(150);
    player.RemoveCustomAttribute("max health additive penalty");
    player.AddCustomAttribute("max health additive penalty", -50, -1);

    local steamId = GetPropString(player, "m_szNetworkIDString");
    local indexStr = steamId.len() > 5 ? steamId.slice(5) : "4444444";
    local index = indexStr.tointeger();
    SetEntityColor(player, [index % 256, (index >> 8) % 256, (index >> 16) % 256]);

    PullOutWeapon(player, GetWeaponTypeByName("crowbar"));
    PullOutWeapon(player, GetCurrentGunGameWeapon(player));

    player.AddCondEx(TF_COND_INVULNERABLE, GetRoundState() == 3 ? 5 : 3, null);

    RunWithDelayPlayer(this, -1, function(player)
    {
        player.SetHealth(150);
        player.SetMaxHealth(150);
    }, player);

    RunWithDelayPlayer(this, GetRoundState() == 3 ? 5 : 3, function(player)
    {
        SetPropInt(player, "m_nForcedSkin", 4);
    }, player)

    if (GetRoundState() >= 4)
        CreateAoE(player.GetOrigin(), 500, function(target, deltaVector, distance) {
            for (local i = 0; i < 10; i++)
            EmitSoundEx({
                sound_name = "CaptureFlag.FlagSpawn",
                volume = 1,
                soundlevel = 150,
                flags = 1,
                channel = i,
                entity = player,
                speaker_entity = player
            });
        }, function(target, deltaVector, distance) {})
}

OnGameEvent("player_death", 0, function(player, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && player != attacker)
    {
        local particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red_shower",
            origin = attacker.GetCenter(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red",
            origin = attacker.GetOrigin(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        local oldHealth = attacker.GetHealth();
        local newHealth = clampCeiling(oldHealth + 50, attacker.GetMaxHealth() + 50);
        attacker.SetHealth(newHealth);
        SendGlobalGameEvent("player_healonhit", {
            entindex = attacker.entindex(),
            amount = newHealth - oldHealth
        });
        SwitchToNextWeapon(attacker);
    }
});

::GetCurrentGunGameWeapon <- function(player)
{
    return GetWeaponTypeByName(GUNGAME_ORDER[currentWeapons[player.entindex()]]);
}
