movespeeds <- player_collection(0);
spareTimeStamp <- player_collection(0);
hasJumped <- player_collection(0);

PrecacheSound("vo/mercenary_jump01.wav")
PrecacheSound("vo/mercenary_jump02.wav")
PrecacheSound("vo/mercenary_jump03.wav")

vo_jump_sounds <- ["vo/mercenary_jump01.wav", "vo/mercenary_jump02.wav", "vo/mercenary_jump03.wav"]

AddTimer(-1, 0, function()
{
    foreach(player in GetAlivePlayers())
    {
        local entIndex = player.entindex();
        if (player.GetFlags() & FL_ONGROUND)
            hasJumped[entIndex] = false;
        else if (!hasJumped[entIndex] && (GetPropInt(player, "m_nButtons") & IN_JUMP))
        {
            hasJumped[entIndex] = true;
            player.EmitSound(vo_jump_sounds[RandomInt(0, vo_jump_sounds.len() - 1)]);
            //YeetPlayer(player, player.GetForwardVector() * 300);
        }

        /*SetPropEntity(player, "m_hGroundEntity", null);
        player.RemoveFlag(FL_ONGROUND);
        player.AddFlag(FL_INWATER)
        player.AddFlag(FL_FLY)
        player.AddFlag(FL_SWIM)*/

        local newSpeed = player.GetAbsVelocity().Length2D();
        if (newSpeed > 310 && !(player.GetFlags() & FL_ONGROUND))
        {
            local delta = (newSpeed - 310) / 520;
            spareTimeStamp[entIndex] = Time();
            if (movespeeds[entIndex] < 70)
                movespeeds[entIndex] += 0.2 + delta;
        }
        else if (newSpeed < 250)
        {
            movespeeds[entIndex] = clampFloor(0, movespeeds[entIndex] - 2);
        }
        else if (Time() - spareTimeStamp[entIndex] > 0.2)
        {
            movespeeds[entIndex] = clampFloor(0, movespeeds[entIndex] - 1.2);
        }
        if (player.GetAbsVelocity().Length2D() > 480)
            player.AddCondEx(TF_COND_SPEED_BOOST, 0.3, player);
        //printl(newSpeed + " " + movespeeds[entIndex] + " " + (1.3 + movespeeds[entIndex] / 70.0))
        //printl(movespeeds[entIndex] + " -> " + (1.3 + movespeeds[entIndex] / 70.0))
        local playerClass = player.GetPlayerClass();
        local classMultiplier = playerClass ==  TF_CLASS_DEMOMAN ? 0.93 : 0.8;
        if (RandomInt(1, 10) == 1)
            player.AddCustomAttribute("move speed bonus", 1.04 / classMultiplier + movespeeds[entIndex] / 70.0, -1);
    }
});