::handsModels <- player_collection(null);
::viewModels <- player_collection(null);
::worldModels <- player_collection(null);

::RefreshModels <- function(player, params = null)
{
    RunWithDelayPlayer(this, -1, RefreshModels2, player);
}

::RefreshModels2 <- function(player)
{
    local heldWeaponTT = heldWeapons[player.entindex()];
    if (!heldWeaponTT)
        return;

    local entsToKill = [];
    for(local viewmodel = null; viewmodel = Entities.FindByClassname(viewmodel, "tf_wearable*");)
        if (viewmodel.GetOwner() == player)
            entsToKill.push(viewmodel);
    foreach (ent in entsToKill)
        ent.Kill();

    local weapon = player.GetActiveWeapon();
    GetPropEntity(player, "m_hViewModel").DisableDraw();

    TrySpawnViewModel(player).SetModelSimple("models/weapons/c_models/c_merc_arms.mdl");

    if ("animmodel" in heldWeaponTT)
    {
        weapon.SetModelSimple(heldWeaponTT.animmodel);
        weapon.SetCustomViewModelModelIndex(GetModelIndex(heldWeaponTT.animmodel));
        SetPropInt(weapon, "m_iViewModelIndex", GetModelIndex(heldWeaponTT.animmodel));
    }
    if ("weaponmodel" in heldWeaponTT)
    {
        TrySpawnViewModel(player).SetModelSimple(heldWeaponTT.weaponmodel);
        TrySpawnWorldModel(player).SetModelSimple(heldWeaponTT.weaponmodel);
        weapon.DisableDraw();
    }
    else
    {
        SetPropInt(TrySpawnViewModel(player), "m_nModelIndex", GetPropInt(weapon, "m_iWorldModelIndex"))
    }
}

OnGameEvent("player_spawn_post", 10, RefreshModels);

::GetWorldModel <- function(player)
{
    return worldModels[player.entindex()];
}

::TrySpawnWorldModel <- function(player)
{
    local playerIndex = player.entindex();
    /*local oldWorldModel = worldModels[playerIndex];
    if (oldWorldModel && oldWorldModel.IsValid())
        oldWorldModel.Kill();*/
    local worldModel = SpawnEntityFromTable("tf_wearable", { });
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	//worldModel.SetModelSimple(model);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, player, player);
	SetPropEntity(worldModel, "m_hOwnerEntity", player);
    worldModel.SetOwner(player);

    worldModels[playerIndex] = worldModel;

	return worldModel;
}

::TrySpawnHandsModel <- function(player)
{
    local playerIndex = player.entindex();
    local oldHands = handsModels[playerIndex];
    if (oldHands && oldHands.IsValid())
        oldHands.Kill();

    local handsModel = SpawnEntityFromTable("tf_wearable_vm", {
        modelindex = PrecacheModel("models/weapons/c_models/c_merc_arms.mdl")
    })
    SetPropBool(handsModel, "m_bForcePurgeFixedupStrings", true);
    player.EquipWearableViewModel(handsModel);
    handsModels[playerIndex] = handsModel;

	return handsModel;
}

::TrySpawnViewModel <- function(player)
{
    local playerIndex = player.entindex();

    local viewModel = SpawnEntityFromTable("tf_wearable_vm", { })
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
    player.EquipWearableViewModel(viewModel);
    viewModels[playerIndex] = viewModel;

	return viewModel;
}