IncludeScript("gungame/weapons/weapon_fixes.nut");
IncludeScript("gungame/weapons/weapon_list.nut");

PrecacheModel("models/weapons/c_models/c_merc_arms.mdl")

AddTimer(-1, -10, function ()
{
    local crowbarTT = GetWeaponTypeByName("crowbar");
    local goldenCrowbarTT = GetWeaponTypeByName("golden_crowbar");
    foreach (player in GetAlivePlayers())
    {
        if (player.GetActiveWeapon() == null || IsSword(player.GetActiveWeapon()))
            continue;
        if (player.GetActiveWeapon().GetSlot() == 2)
        {
            local heldWeapon = heldWeapons[player.entindex()];
            if (heldWeapon != crowbarTT && heldWeapon != goldenCrowbarTT)
                PullOutFix(player, crowbarTT);
        }
        else
        {
            local heldWeapon = heldWeapons[player.entindex()];
            if (heldWeapon == crowbarTT)
                PullOutFix(player, GetCurrentGunGameWeapon(player));
        }
    }
});

::PullOutFix <- function(player, weaponTT)
{
    //local realWeapon = heldWeapons[player.entindex()]
    heldWeapons[player.entindex()] = weaponTT;
    RefreshModels2(player);
    //heldWeapons[player.entindex()] = realWeapon;
}

::PullOutWeapon <- function(player, weaponTT)
{
    local weaponEntity = GivePlayerWeapon(player, weaponTT.baseclass, weaponTT.baseid, "script" in weaponTT ? weaponTT.script : null)
    heldWeapons[player.entindex()] = weaponTT;
    if ("onPullOut" in weaponTT)
        weaponTT.onPullOut(player, weaponEntity);

    RefreshModels2(player);
}
